#include "nexnooper.h"

#define SC_DRAGMOVE 0xF012

#define BACKGROUND_COLOR RGB(4, 2, 68) // RGB(0, 0, 64)
#define TEXT_COLOR RGB(255, 191, 191)

HBRUSH g_hBrush;
HCURSOR g_hCursor;

LONG g_lListDefWndProc, g_lRefreshButtonDefWndProc, g_lSettingsButtonDefWndProc;

LRESULT CALLBACK ListWndProc(HWND hWnd, UINT nMsg, WPARAM wParam, LPARAM lParam)
{
	switch (nMsg)
	{
		case WM_LBUTTONDOWN:
   {
    LRESULT r = CallWindowProc((WNDPROC)g_lListDefWndProc, hWnd, nMsg, wParam, lParam);
			 // SendMessage(hWnd, WM_LBUTTONUP, wParam, lParam);
			 SendMessage(g_hDlg, WM_SYSCOMMAND, (WPARAM)SC_DRAGMOVE, 0);
    return r;
   }
  case WM_WINDOWPOSCHANGING:
   ShowScrollBar(g_hGamesList, SB_HORZ, FALSE);
   break;
		case WM_LBUTTONDBLCLK:
			JoinGame();
			return TRUE;
  case WM_SETCURSOR:
   SetCursor(g_hCursor);
   return TRUE;
 }
 return CallWindowProc((WNDPROC)g_lListDefWndProc, hWnd, nMsg, wParam, lParam);
}


#define REFRESH_BUTTON_WIDTH 100
#define SETTINGS_BUTTON_WIDTH 20
#define BUTTON_HEIGHT 20
HANDLE g_hBmpRefresh1, g_hBmpRefresh2, g_hBmpRefresh3;
HANDLE g_hBmpSettings1, g_hBmpSettings2, g_hBmpSettings3;
BOOL g_bRefreshButtonClicked = FALSE, g_bRefreshButtonColorDefault = TRUE;
BOOL g_bSettingsButtonClicked = FALSE, g_bSettingsButtonColorDefault = TRUE;
BOOL g_bMouseCaptured = FALSE;

LRESULT CALLBACK ButtonWndProc(HWND hWnd, UINT nMsg, WPARAM wParam, LPARAM lParam)
{
 BOOL *pbButtonClicked, *pbButtonColorDefault;
 HANDLE hBmp1, hBmp2, hBmp3;
 UINT nButtonWidth;
 LONG lDefWndProc;
 UINT nButtonResourceId;
 if (hWnd == g_hBtnRefresh)
 {
  pbButtonClicked = &g_bRefreshButtonClicked; pbButtonColorDefault = &g_bRefreshButtonColorDefault;
  hBmp1 = g_hBmpRefresh1; hBmp2 = g_hBmpRefresh2; hBmp3 = g_hBmpRefresh3;
  nButtonWidth = REFRESH_BUTTON_WIDTH;
  lDefWndProc = g_lRefreshButtonDefWndProc;
  nButtonResourceId = ID_PIC_REFRESHBUTTON;
 }
 else
 {
  pbButtonClicked = &g_bSettingsButtonClicked; pbButtonColorDefault = &g_bSettingsButtonColorDefault;
  hBmp1 = g_hBmpSettings1; hBmp2 = g_hBmpSettings2; hBmp3 = g_hBmpSettings3;
  nButtonWidth = SETTINGS_BUTTON_WIDTH;
  lDefWndProc = g_lSettingsButtonDefWndProc;
  nButtonResourceId = ID_PIC_SETTINGSBUTTON;
 }

	switch (nMsg)
	{
  case WM_SETCURSOR:
   SetCursor(g_hCursor);
   return TRUE;
  case WM_CAPTURECHANGED:
   if (g_bMouseCaptured)
   {
    g_bMouseCaptured = FALSE;
    if (*pbButtonClicked) *pbButtonClicked = FALSE;
    if (!*pbButtonColorDefault)
    {
     *pbButtonColorDefault = TRUE;
     SendMessage(hWnd, STM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)hBmp1);
    }
    return FALSE;
   }
   break;
  case WM_MOUSEMOVE:
   if (LOWORD(lParam) < 0 || HIWORD(lParam) < 0
    || LOWORD(lParam) > nButtonWidth || HIWORD(lParam) > BUTTON_HEIGHT)
   {
    if (!*pbButtonClicked)
    {
     g_bMouseCaptured = FALSE;
     ReleaseCapture();
    }
    if (!*pbButtonColorDefault)
    {
     *pbButtonColorDefault = TRUE;
     SendMessage(hWnd, STM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)hBmp1);
    }
   }
   else
   {
    if (!g_bMouseCaptured)
     { g_bMouseCaptured = TRUE; SetCapture(hWnd); }
    if (*pbButtonColorDefault)
    {
     *pbButtonColorDefault = FALSE;
     SendMessage(hWnd, STM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)(*pbButtonClicked ? hBmp3 : hBmp2));
    }
   }
   break;
  case WM_LBUTTONDOWN:
  case WM_LBUTTONDBLCLK:
   *pbButtonClicked = TRUE;
   SendMessage(hWnd, STM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)hBmp3);
   return TRUE;
  case WM_LBUTTONUP:
   *pbButtonClicked = FALSE;
   if (LOWORD(lParam) < 0 || HIWORD(lParam) < 0
    || LOWORD(lParam) > nButtonWidth || HIWORD(lParam) > BUTTON_HEIGHT)
   {
    g_bMouseCaptured = FALSE; ReleaseCapture();
    SendMessage(hWnd, STM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)hBmp1);
   }
   else
   {
    PostMessage(g_hDlg, WM_COMMAND, MAKEWPARAM(nButtonResourceId, BN_CLICKED), (LPARAM)hWnd);
    SendMessage(hWnd, STM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)hBmp2);
   }
   break;
 }
 return CallWindowProc((WNDPROC)lDefWndProc, hWnd, nMsg, wParam, lParam);
}


HINSTANCE g_hInst;


BOOL CALLBACK SettingsDlgProc(HWND hDlg, UINT nMsg, WPARAM wParam, LPARAM lParam)
{
 switch (nMsg)
 {
  case WM_INITDIALOG:
   CheckDlgButton(hDlg, ID_CHK_AUTOREFRESH, g_bAutoRefresh ? BST_CHECKED : BST_UNCHECKED);
   CheckDlgButton(hDlg, ID_CHK_NOTIFYWITHSOUND, g_bNotifyWithSound ? BST_CHECKED : BST_UNCHECKED);
   CheckDlgButton(hDlg, ID_CHK_DISABLEWHILEPLAYING, g_bDisableWhilePlaying ? BST_CHECKED : BST_UNCHECKED);
   break;
  case WM_COMMAND:
   switch (LOWORD(wParam))
   {
    case IDOK:
     g_bAutoRefresh = (BST_CHECKED == IsDlgButtonChecked(hDlg, ID_CHK_AUTOREFRESH));
     g_bNotifyWithSound = (BST_CHECKED == IsDlgButtonChecked(hDlg, ID_CHK_NOTIFYWITHSOUND));
     g_bDisableWhilePlaying = (BST_CHECKED == IsDlgButtonChecked(hDlg, ID_CHK_DISABLEWHILEPLAYING));
    case IDCANCEL:
     EndDialog(hDlg, 0);
   }
   return FALSE;
  default:
   return FALSE;
 }
 return TRUE;
}


BOOL CALLBACK MainDlgProc(HWND hDlg, UINT nMsg, WPARAM wParam, LPARAM lParam)
{
 switch (nMsg)
 {
  case WM_INITDIALOG:
   SendMessage(hDlg, WM_SETICON, ICON_BIG, (LPARAM)LoadIcon(GetModuleHandle(NULL), MAKEINTRESOURCE(ID_ICO_MAIN)));
   g_hDlg = hDlg;
   g_hGamesList = GetDlgItem(hDlg, ID_LST_GAMES);
   g_hBtnRefresh = GetDlgItem(hDlg, ID_PIC_REFRESHBUTTON);
   g_hBtnSettings = GetDlgItem(hDlg, ID_PIC_SETTINGSBUTTON);

   g_hBmpRefresh1 = LoadImage(g_hInst, MAKEINTRESOURCE(ID_BMP_REFRESH1), IMAGE_BITMAP, 0, 0, 0);
   g_hBmpRefresh2 = LoadImage(g_hInst, MAKEINTRESOURCE(ID_BMP_REFRESH2), IMAGE_BITMAP, 0, 0, 0);
   g_hBmpRefresh3 = LoadImage(g_hInst, MAKEINTRESOURCE(ID_BMP_REFRESH3), IMAGE_BITMAP, 0, 0, 0);
   g_hBmpSettings1 = LoadImage(g_hInst, MAKEINTRESOURCE(ID_BMP_SETTINGS1), IMAGE_BITMAP, 0, 0, 0);
   g_hBmpSettings2 = LoadImage(g_hInst, MAKEINTRESOURCE(ID_BMP_SETTINGS2), IMAGE_BITMAP, 0, 0, 0);
   g_hBmpSettings3 = LoadImage(g_hInst, MAKEINTRESOURCE(ID_BMP_SETTINGS3), IMAGE_BITMAP, 0, 0, 0);

   g_lListDefWndProc = SetWindowLong(g_hGamesList, GWL_WNDPROC, (LONG)ListWndProc);
   g_lRefreshButtonDefWndProc = SetWindowLong(g_hBtnRefresh, GWL_WNDPROC, (LONG)ButtonWndProc);
   g_lSettingsButtonDefWndProc = SetWindowLong(g_hBtnSettings, GWL_WNDPROC, (LONG)ButtonWndProc);

   {
    LV_COLUMN lvc;

  	 ListView_SetBkColor(g_hGamesList, BACKGROUND_COLOR);
	   ListView_SetTextBkColor(g_hGamesList, BACKGROUND_COLOR);
	   ListView_SetTextColor(g_hGamesList, TEXT_COLOR);
    ListView_SetExtendedListViewStyle(g_hGamesList, LVS_EX_FULLROWSELECT|LVS_EX_SUBITEMIMAGES);

    lvc.mask = LVCF_WIDTH;

    lvc.cx = 25;
    ListView_InsertColumn(g_hGamesList, 0, &lvc);

    lvc.cx = 22;
    ListView_InsertColumn(g_hGamesList, 1, &lvc);

	   lvc.cx = 389; // 377
	   ListView_InsertColumn(g_hGamesList, 2, &lvc);

	   lvc.cx = 10000; // 220; // 208
	   ListView_InsertColumn(g_hGamesList, 3, &lvc);

    lvc.cx = 0;
    ListView_InsertColumn(g_hGamesList, 4, &lvc);
   }

   g_hFlagsImageList = ImageList_LoadImage(g_hInst, MAKEINTRESOURCE(ID_BMP_FLAGS), 22, 86, CLR_NONE, IMAGE_BITMAP, LR_CREATEDIBSECTION /*LR_LOADFROMFILE|LR_LOADTRANSPARENT*/);
   ListView_SetImageList(g_hGamesList, g_hFlagsImageList, LVSIL_SMALL);

   g_hBrush = CreateSolidBrush(BACKGROUND_COLOR);
   g_hCursor = LoadCursor(g_hInst, MAKEINTRESOURCE(ID_CUR_ARROW));

   // PlaySound("c:/Games/Worms Armageddon/FESfx/menu-loop.wav", NULL, SND_FILENAME|SND_ASYNC|SND_LOOP);

   fwi.cbSize = sizeof(fwi);
   fwi.hwnd = g_hDlg;
   fwi.dwFlags = FLASHW_TRAY;
   fwi.uCount = 3;
   fwi.dwTimeout = 50;

   // UpdateGamesList();
   break;

	/*
  case WM_RBUTTONDOWN:
   {
    SIZE size1, size2;
    HFONT hFont = (HFONT)SendMessage(g_hGamesList, WM_GETFONT, 0, 0);
    HDC hDC = GetDC(g_hGamesList);
    SelectObject(hDC, hFont);
    GetTextExtentPoint32(hDC, "WWWWWWWWWWWWWWWWWWWWWWWWWWWWW", 29, &size1);
    GetTextExtentPoint32(hDC, "WWWWWWWWWWWWWWWW", 16, &size2);
    ReleaseDC(g_hGamesList, hDC);
    wsprintf(sTmp, "%d\n%d", size1.cx, size2.cx);
    MessageBox(hDlg, sTmp, "", MB_OK);
   }
   break;
	*/

  case WM_LBUTTONDOWN:
   SendMessage(g_hDlg, WM_SYSCOMMAND, (WPARAM)SC_DRAGMOVE, 0);
   return FALSE;
  case WM_SETCURSOR:
   DefWindowProc(hDlg, nMsg, wParam, lParam);
   if (LOWORD(lParam) == HTCLIENT)
   {
    SetCursor(g_hCursor);
   }
   break;

	/*
  case WM_TIMER:
   if (g_bProcessing)
    break;
   KillTimer(g_hWnd, 0);
   if (!g_bSuccess)
    SetWindowText(hDlg, g_pcsStatusError);
   break;
  */

	case WM_CTLCOLORDLG:
  case WM_CTLCOLORBTN:
	case WM_CTLCOLORLISTBOX:
	case WM_CTLCOLOREDIT:
	case WM_CTLCOLORSTATIC:
			SetTextColor((HDC)wParam, TEXT_COLOR);
			SetBkColor((HDC)wParam, BACKGROUND_COLOR);
			return (BOOL)g_hBrush;
  case WM_COMMAND:
   switch (LOWORD(wParam))
   {
    case ID_PIC_REFRESHBUTTON:
     if (g_bProcessing)
      { TerminateThread(g_hRefreshingThread, 0); closesocket(s); }
     if (g_hWaitingThread)
      { TerminateThread(g_hWaitingThread, 0); g_hWaitingThread = NULL; }
     UpdateGamesList();
     break;
    case ID_PIC_SETTINGSBUTTON:
     {
      // HWND hSettingsDlg = CreateDialog(g_hInst, MAKEINTRESOURCE(ID_DLG_SETTINGS), hDlg, SettingsDlgProc);
      // ShowWindow(hSettingsDlg, SW_SHOW);
      DialogBox(g_hInst, MAKEINTRESOURCE(ID_DLG_SETTINGS), hDlg, SettingsDlgProc);
     }
   }
   return FALSE;
  case WM_CLOSE:
   if (g_bProcessing)
    { TerminateThread(g_hRefreshingThread, 0); closesocket(s); }
   if (g_hWaitingThread)
    TerminateThread(g_hWaitingThread, 0);
   EndDialog(hDlg, 0);
  default:
   return FALSE;
 }
 return TRUE;
}
